/* eslint-disable import/no-extraneous-dependencies, global-require, @typescript-eslint/no-var-requires */

const fs = require('fs');
const os = require('os');
const path = require('path');
const util = require('util');
const webpack = require('webpack');
const {BundleAnalyzerPlugin} = require('webpack-bundle-analyzer');

const config = require('../configs/webpack.prod');

const nodeMakeTmpDir = util.promisify(fs.mkdtemp);

const makeTmpDir = async () => {
  await nodeMakeTmpDir(`${os.tmpdir()}${path.sep}`);
};

const run = async () => {
  const tmpDir = await makeTmpDir();
  config?.plugins?.push(new BundleAnalyzerPlugin());
  config.output.path = tmpDir;
  webpack(config).run(() => {});
};

run();

/* eslint-enable import/no-extraneous-dependencies, global-require, @typescript-eslint/no-var-requires */
